function [solids,deformers] = enforce_global_constraints( solids, deformers )
global x_ y_ z_ s_ p_ v_ f_ r_ N
global R m c_f_gravity M

for iS = 1:length(solids)
    S = solids{iS};
    
    for iD = 1:length(deformers)
        D = deformers{iD};
                
        for i = 1:size(S,1)
            s = S(i,:,p_);
            d = D(1,:,p_);
            
            if norm(s-d) >= R
                continue
            end
            
            dr = 0.01;
            s = (R+dr)/norm(s-d) * (s-d) + d;
            S(i,:,p_) = s;
            
            % Apply normal force
            F = d-s;
            F = F / norm(F);
            F = -dot(c_f_gravity, F) * F;
                        
            D(1,:,f_) = D(1,:,f_) + m*F;
            S(i,:,f_) = S(i,:,f_) - M*F;
        end
        deformers{iD} = D;
    end
    
    solids{iS} = S;
end

end