function ydot = ode(t,Y)

global N D m dt tMax c_damping c_f_gravity
global x_ y_ z_ s_ p_ v_ f_

rdot = Y(:,:,v_);

vdot = zeros(size(Y,1),size(Y,2));

for i = 1:size(Y,1)
    F = Y(i,:,f_);
    
    p = Y(i,:,p_);
    p0 = Y(i,:,s_);
    F = F + potential(p,p0);
    
    % Damping force
    F_damping = -c_damping * Y(i,:,v_);
    F = F + F_damping;
    
    % Gravity
    F = F + c_f_gravity;
    
    Y(i,:,f_) = F;
    
    vdot(i,:) = F / m;
end

ydot = zeros(size(Y));
ydot(:,:,p_) = rdot;
ydot(:,:,v_) = vdot;

end