function plotstuff(Y)
view( [130 40] );
hold on;
colormap jet;
% plotstuff_helper(Y0,'r',':');
plotstuff_helper(Y,'b','-');
shading faceted;
grid on;
axis( 1.5 * [0 1 0 1 0 1] );
end

function plotstuff_helper(Y,color,linetype)
global x_ y_ z_ s_ p_ v_ f_
global N D


x = Y(:,x_,p_);
y = Y(:,y_,p_);
z = Y(:,z_,p_);

plot3( x, y, z, sprintf('%s.',color) );

nn = size(Y,1);
faces = zeros(0,4);
for i = 1:nn
    f = [
          i i+N i+N+1 i+1;
          i i+N^2 i+N^2+1 i+1;
          i i+N^2 i+N^2+N i+N
        ];
          
    for i_f = 1:size(f,1)
        if sum( f(i_f,:) > nn ) > 0
            continue
        end
        if mod( i-1, N ) == N-1 || mod( floor(i/N), N ) == N-1
            continue
        end
        faces(end+1,:) = f(i_f,:);
    end
    
end
patch( 'Vertices', Y(:,:,p_), 'Faces', faces, 'FaceVertexCData', jet(size(faces,1)), 'FaceColor', 'flat' );

end

function drawpatch(X,Y,Z)
c = [.5 1 .5];
patch( X, Y, Z, c );
end

function M = zeropad(M)
M = conv2( M, [0 0 0; 0 1 0; 0 0 0] );
end

function V = extend(V)
dV = 0.1;
V = [ V(1)-dV V V(end)+dV ];
end

function plotit_2(Y,i,j,color,linetype)
plot( Y( [i j],1,1), Y( [i j],2,1), sprintf('%s%s',color,linetype) );
end

function plotit(Y,i,j,color,linetype)
view( [45 45] );
plot3( Y( [i j],1,1 ), Y( [i j],3,1), Y( [i j],2,1 ), sprintf('%s%s',color,linetype) );
end